# coding: utf-8

"""
    Middleware

    Knowledge Graph data management.

    The version of the OpenAPI document: 1.0
    Contact: hello@wordlift.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class OAuth2AuthorizedClientRequest(BaseModel):
    """
    The OAuth2 Authorized Client request
    """ # noqa: E501
    access_token_expires_at: Optional[datetime] = Field(default=None, description="When the Access Token expires")
    access_token_issued_at: Optional[datetime] = Field(default=None, description="When the Access Token was issued")
    access_token_scopes: Optional[StrictStr] = Field(default=None, description="The Access Token scopes")
    access_token_type: Optional[StrictStr] = Field(default=None, description="The Access Token Type")
    access_token_value: Optional[StrictStr] = Field(default=None, description="The Access Token Value")
    client_registration_id: Optional[StrictStr] = Field(default=None, description="The Client Registration Id")
    principal_name: Optional[StrictStr] = Field(default=None, description="The Principal Name")
    refresh_token_issued_at: Optional[datetime] = Field(default=None, description="When the Access Token was issued")
    refresh_token_value: Optional[StrictStr] = Field(default=None, description="The Refresh Token Value")
    __properties: ClassVar[List[str]] = ["access_token_expires_at", "access_token_issued_at", "access_token_scopes", "access_token_type", "access_token_value", "client_registration_id", "principal_name", "refresh_token_issued_at", "refresh_token_value"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OAuth2AuthorizedClientRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OAuth2AuthorizedClientRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "access_token_expires_at": obj.get("access_token_expires_at"),
            "access_token_issued_at": obj.get("access_token_issued_at"),
            "access_token_scopes": obj.get("access_token_scopes"),
            "access_token_type": obj.get("access_token_type"),
            "access_token_value": obj.get("access_token_value"),
            "client_registration_id": obj.get("client_registration_id"),
            "principal_name": obj.get("principal_name"),
            "refresh_token_issued_at": obj.get("refresh_token_issued_at"),
            "refresh_token_value": obj.get("refresh_token_value")
        })
        return _obj


